source('CFU_EOF.txt')
library(s2dverification)

nt=3
neofs=nt
ny=5
nx=4
a=array(rnorm(nt*ny*nx),dim=c(nt,ny,nx))
a=a-InsertDim(Mean1Dim(a,1),1,nt)
lon=c(20,25,30,35)
lat=c(20,25,30,35,40)

#Within CFU_EOF
b=CFU_EOF(lon,lat,a)
# a has dims lat,lon so EOFs should have the same dims. To be corrected in CFU_EOF

#Without CFU_EOF
#abis=array(a,dim=c(nt,ny*nx))
#b=La.svd(abis)
#EOF=array(b$v,dim=c(neofs,ny,nx))
#PC=b$u

print(dim(b$EOFs))
test=array(0,dim=dim(a))
for (i in 1:nt) {
  for (j in 1:neofs) {
    # Check within CFU_EOF
    #test[i,,]=test[i,,]+t(b$PC)[j,i]*b$EOF[j,,]*sqrt(b$Var[j]*var(a))*InsertDim(cos(lat),2,nx)/(sum(cos(lat))*nx) # With weights and Var
    #test[i,,]=test[i,,]+t(b$PC)[j,i]*b$EOF[j,,]*b$D[j]*InsertDim(cos(lat*pi/180),2,nx)/sum(cos(lat*pi/180)*nx) # With weights
    test[i,,]=test[i,,]+b$PCs[i,j]*b$EOFs[j,,]*b$D[j]

    # Check without CFU_EOF
    #test[i,,]=test[i,,]+PC[i,j]*EOF[j,,]*b$d[j] # Check without CFU_EOF
  }
}


